<?php
/**
 * @version $Id: rssnevobo.php  2008-03-04 22:47 
 * @package     Joomla
 * @subpackage	Content
 * @copyright	Copyright (C) 2005 - 2007 Open Source Matters. All rights reserved.
 * @license		GNU/GPL, see LICENSE.php
 * Joomla! is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * See COPYRIGHT.php for copyright notices and details.

 * 0.2   changed heading 
 * 0.3 	 added programma function
 * 0.4.2 added filtering and points
 * 0.4.3 Het tonen van de stand van een poule incl. set en punten saldo
 *       Het tonen van het programma van een poule met de mogelijkheid om te filteren op een teamnaam
 *       Het tonen van de uitslagen van een poule met de mogelijkheid om te filteren op een teamnaam
 *       kleine layout aanpassingen
 * 0.4.4 wedstrijd in een kolom, en mogelijkheid om wedstrijdnummer niet te tonen, max aantal te tonen wedstrijden instelbaar
 * 0.5   geschikt gemaakt voor joomla 1.6
 * 0.5.1 Met dank aan Fred Peek aangepast aan de nieuwe Nevobo site
 * 0.5.2 sortering feeds aangepast
 * 0.5.3 styling
 * 0.5.4 datum uniform gemaakt, regular expressions toegepast. Wedstrijd nr verwijderd.
 * 0.5.5 uitbreiding styling, gebruik styling op basis van parameter instelling
 * 0.6.0 switchen van simplepie naar simplexml parser, waardoor quote's ook goed worden geparsed. &amp; wordt nu ook geaccepteerd in link
 * 0.6.1 aanpassing ivm lege programma's
 * 0.6.2 kleine aanpassing _callback functie
 * 0.6.3 allow url fopen workaround middels curl toegevoegd; Maand mei workaround toegevoegd
 * 0.6.5 final version, no fixes
*/
defined( '_JEXEC' ) or die();

jimport('joomla.plugin.plugin');


class plgContentrssnevobo extends JPlugin
{
	/**
	 * @param	string	The context of the content being passed to the plugin.
	 * @param	object	The article object.  Note $article->text is also available
	 * @param	object	The article params
	 * @param	int		The 'page' number
	 */
	public function onContentPrepare($context, &$article, &$params, $page = 0)
	{
		// Simple performance check to determine whether bot should process further.
		if (JString::strpos($article->text, 'rssnevobo') === false) {
			return true;
		}
		$document = JFactory::getDocument();
		$mystyle = $this->params->get('stijl', '');
		$document->addStyleSheet(JURI::root().'plugins/content/rssnevobo/rssnevobo-'.$mystyle.'.css');		
		
		// Define the regular expression for the bot.
		$regex = "#{rssnevobo*(.*?)}(.*?){/rssnevobo}#s";
		
		// Perform the replacement.
		$article->text = preg_replace_callback($regex, array(&$this, '_replace'), $article->text);

		return true;
	}
	
	protected function _replace(&$matches)
	{
		jimport('joomla.utilities.utility');

		$args = JUtility::parseAttributes($matches[1]);
		$rssurl = strip_tags(trim($matches[2]));
		if (get_magic_quotes_gpc())
		{
			$rssurl = stripslashes($rssurl);
		}

		$rsscache = (int)JArrayHelper::getValue($args, 'cache', '10');
		$rssfilter = JArrayHelper::getValue($args, 'filter','');

		$rssaantal = (int)JArrayHelper::getValue($args,'aantal',999);
		$rsstype = (int)JArrayHelper::getValue($args,'type',0); // type: 0=stand; 1=programma
		$rssitems 			= 999;
		$content_buffer     = '';
		$params0 = '';
		$numstr = '';
		$dummy = "Nog geen programma bekend";		
		if ($rssurl != "") { 			// only if array element is not empty

			// get RSS parsed object
			$rssurl = str_replace('&amp;', "&",$rssurl);   //robuuster gemaakt, editor vervangt & namelijk steeds door &amp; op de achtergrond
			
			// $xml=simplexml_load_file($rssurl); versie 0.6.3 vervangen door workaround oplossing
			
			$xml= $this->_loadxml($rssurl);
	
		  	if (!$xml) {
				echo "Failed loading XML\n";
				foreach(libxml_get_errors() as $error) {
					echo "\t", $error->message;
					return;
				}
			}
    		$content_buffer .= '<div style="direction: ' . 'ltr; ' . 'text-align: '. 'left;' .'">';
			$content_buffer .= '<table id="nevobotable">';			
			if ($rsstype==0) {   // stand
				$content_buffer .= '<thead><tr><th class="topleft">Team</th><th align="right">Wedstrijden</th><th class="topright" align="right">Punten</th></tr></thead><tbody>';
			} else if ($rsstype==1) { // programma
				$content_buffer .= '<thead><tr><th class="topleft">Datum</th><th>Tijd</th><th>Wedstrijd</th><th>Sporthal</th><th class="topright">Plaats</th></tr></thead><tbody>';	
			} else  //rsstype = 2 uitslagen 
			{
				$content_buffer .= '<thead><tr>' . '<th class="topleft">Datum</th><th>Tijd</th><th>Wedstrijd</th><th align="right">Uitslag</th><th class="topright">Setstanden</th></tr></thead><tbody>';	
			}
						
			$totalItems = count($xml->channel[0]->item);

			for ($i=0; $i<$totalItems;$i++) {		

//	<description>
//		<![CDATA[# Team<br />1. Volga HS 1, wedstr: 15, punten: 66<br />2. Reflex HS 1, wedstr: 15, punten: 56<br />3. Victoria HS 1, wedstr: 15, punten: 47<br />4. Wevoc HS 1, wedstr: 14, punten: 42<br />5. Kerkemeijer Gemini HS 1, wedstr: 15, punten: 39<br />6. AAA BOVO HS 2, wedstr: 15, punten: 39<br />7. WSV HS 1, wedstr: 15, punten: 38<br />8. Dynamo-Neede HS 1, wedstr: 15, punten: 37<br />9. BVC'73 HS 1, wedstr: 15, punten: 31<br />10. Avanti HS 1, wedstr: 15, punten: 25<br />11. Favorita HS 2, wedstr: 15, punten: 17<br />12. D.V.O. HS 1, wedstr: 16, punten: 13<br />]]>
//	</description>						
				if ($rsstype==0){ 																				//stand				
					$text = $xml->channel[0]->item[$i]->description; 	
					$text = str_replace (", wedstr: ",'</td><td align="right">', $text);
					$text = str_replace (", punten: ",'</td><td align="right">', $text);

					$array = explode ("<br />", $text);
					$text = '';
					$arraycount = count ($array);
					for ($k = 1; $k < $arraycount-1; $k++)
					{
						$text.="\n".'<tr '.$this->_isodd($k+1).'><td>'.$array[$k].'</td></tr>';
					}	
					$content_buffer .= $text;
								
				} else if ($rsstype==1 && $rssaantal>0) 
				{ 																							// programma		
//		<title>
//				<![CDATA[Nog geen programma bekend]]>
//		</title>
//	OF	<title>
//			<![CDATA[13 apr 21:00: S.G.O. HS 1 - Pegasus HS 2]]>
//		</title>
//		<link>http://www.volleybal.nl/competitie/team/1226HS+1</link>
//		<description>
//			<![CDATA[Wedstrijd: 1000H2C   EI, Datum: vrijdag 13 april, 21:00, Speellocatie: Markehuis, Grolloo]]>
//		</description>
//		<pubDate>vrij, 13 apr 2012 21:00:00 +0200</pubDate>
//		27 February 2012, 8:00 pm
// 		<tr class ="odd"><td>maandag 27 februari, 21:00</td><td> Wevoc HS 1 - Favorita HS 2</td><td>de Pals, Westervoort</td></tr>
//
					$content_buffer .= "\n";
					if ($this->_checkfilter($dummy, $xml->channel[0]->item[$i]->title)) {
						$rssaantal = $rssaantal - 1;
						$content_buffer .= '<tr '.$this->_isodd($rssaantal).'><td colspan="5">Er is geen programma bekend</td></tr>';
					}
					else if ($this->_checkfilter($rssfilter, $xml->channel[0]->item[$i]->title)) {
						$rssaantal = $rssaantal - 1;
						$content_buffer .= '<tr '.$this->_isodd($rssaantal).'>';
						$regex = '#(.*), (\d*) (.*) (\d*) (\d*):(\d*):(\d*) +(.*)#'; 
						$replacement = '<td>$2-$3-$4</td><td>$5:$6 uur</td>';
						$content_buffer .= preg_replace_callback($regex, array(&$this, '_callback'), $xml->channel[0]->item[$i]->pubDate);
				
						$regex = "#(\d*) (.*) (\d*):(\d*):(.*)#";
						$replacement = '<td>$5</td>';						
						$content_buffer .=  preg_replace($regex, $replacement, $xml->channel[0]->item[$i]->title);

						$regex = "#Wedstrijd: (.*), Datum: (.*), Speellocatie: (.*), (.*)#";
						$replacement = '<td>$3</td><td>$4</td></tr>';
						$content_buffer .= preg_replace($regex, $replacement, $xml->channel[0]->item[$i]->description);
					} 
//		<title>
//			<[CDATA[Avanti HS 1 - AAA BOVO HS 2, Uitslag: 0-4]]>
//		</title>
//		<link>http://www.volleybal.nl/competitie/poule/HPB/5000</link>
//		<guid>http://www.volleybal.nl/competitie/wedstrijd/5000HPB+++BJ</guid>
//		<description>
//			<![CDATA[Wedstrijd: Avanti HS 1 - AAA BOVO HS 2, Uitslag: 0-4, Setstanden: 24-26, 12-25, 14-25, 17-25]]>
//		</description>
//		<pubDate>Sat, 18 Feb 2012 16:00:00 +0100</pubDate>
						
				} else if ($rssaantal>0) {  															// uitslagen						
					$content_buffer .= "\n";			
				
					$title = $xml->channel[0]->item[$i]->title; 
					if ($title == 'Geen uitslagen bekend') {
						$content_buffer .= '<tr><td colspan="5">'.$title. '</td></tr>';
					} else 
					{			
						if ($this->_checkfilter($rssfilter, $xml->channel[0]->item[$i]->title)) {
							$rssaantal = $rssaantal - 1;		
							$content_buffer .= '<tr '.$this->_isodd($rssaantal).'>';	
							$regex = '#(.*), (\d*) (.*) (\d*) (\d*):(\d*):(\d*) +(.*)#'; 
							$replacement = '<td>$2-$3-$4</td>';
							$content_buffer .= preg_replace_callback($regex, array(&$this, '_callback'), $xml->channel[0]->item[$i]->pubDate);
					
							$regex = "#Wedstrijd: (.*), Uitslag: (.*), Setstanden:( .*|)#";
							$replacement = '<td>$1</td><td>$2</td><td>$3</td></tr>';
							$content_buffer .= preg_replace($regex, $replacement, $xml->channel[0]->item[$i]->description);
						}
					}
				}
			}
			$content_buffer .= '</tbody>';
				
			if ($rsstype==0) {   // stand
	    		$content_buffer .= '<tfoot><tr><td class="botleft"></td><td></td><td class="botright"></td></tr></tfoot>';
			} else if ($rsstype==1) { // programma
				$content_buffer .= '<tfoot><tr><td class="botleft"></td><td></td><td></td><td></td><td class="botright"></td></tr></tfoot>';	
			} else  //rsstype = 2 uitslagen 
			{
				$content_buffer .= '<tfoot><tr><td class="botleft"></td><td></td><td></td><td></td><td class="botright"></td></tr></tfoot>';	
			}
			$content_buffer .= '</table>';
		}
		$content_buffer .= '</div>';
		return $content_buffer;
	}

	function _isodd ($nr) {
		$text = ''; 
		if (1 & $nr) { $text = 'class ="odd"'; } 
		return $text;
	}
	
	function _checkfilter ($f, $t) { 				
		if ($f != '') {
			$pos = stripos ($t, $f);
		} else {
			$pos = true;	
		}
		return $pos;
	}
		
	private function _callback ($matches) {
		switch ($matches[3]) {
			case 'Jan': $m = '01';
				break;
			case 'Feb': $m = '02';
				break;
			case 'Mar': $m = '03';
				break;
			case 'Apr': $m = '04';
				break;
			case 'Mei': $m = '05';
				break;
			case 'May': $m = '05';
				break;
			case 'Jun': $m = '06';
				break;
			case 'Jul': $m = '07';
				break;
			case 'Aug': $m = '08';
				break;
			case 'Sep': $m = '09';
				break;
			case 'Oct': $m = '10';
				break;
			case 'Nov': $m = '11';
				break;
			case 'Dec': $m = '12';
				break;
		}
		$text='<td>'.$matches[2].'-'.$m.'-'.$matches[4].'</td><td>'.$matches[5].':'.$matches[6].' uur</td>';
		return $text;
	}
	
	private function _loadxml ($this_url) {
		if (ini_get('allow_url_fopen') == true) {
			$this_xml = simplexml_load_file ($this_url);
		} else 
		
		if (function_exists ('curl_init')) {
			$ch = curl_init ($this_url);
			curl_setopt ($ch, CURLOPT_HEADER, false);
			curl_setopt ($ch, CURLOPT_RETURNTRANSFER, true);
			$xml_raw = curl_exec ($ch);
			$this_xml = simplexml_load_string ($xml_raw);
		} else { echo "Om de feeds op te kunnen halen moet allow_url_fopen aan staan of moet er van curl gebruik gemaakt kunnen worden";} 
		return $this_xml;
	}
	
} // End Class